﻿

Public Class KontaktFilter
    Private mSuchwort As String = String.Empty
    Private mNurJuengerAls As Date
    Private mFilterTypen As Boolean = False
    Private mErlaubterTyp As KontaktTyp = KontaktTyp.Sonstige

    Public Property Suchwort() As String
        Get
            Return mSuchwort
        End Get
        Set(ByVal value As String)
            mSuchwort = value
        End Set
    End Property

    Public Property NurJuengerAls() As Date
        Get
            Return mNurJuengerAls
        End Get
        Set(ByVal value As Date)
            mNurJuengerAls = value
        End Set
    End Property

    Public Property FilterTypen() As Boolean
        Get
            Return mFilterTypen
        End Get
        Set(ByVal value As Boolean)
            mFilterTypen = value
        End Set
    End Property

    Public Property ErlaubterTyp() As KontaktTyp
        Get
            Return mErlaubterTyp
        End Get
        Set(ByVal value As KontaktTyp)
            mErlaubterTyp = value
        End Set
    End Property

    Public Function Filter(ByVal itemObj As Object) As Boolean
        Dim item As Kontakt = TryCast(itemObj, Kontakt)
        If item IsNot Nothing Then
            ' Wenn eine Bedingung nicht erfüllt wird, ist der Item raus
            If mSuchwort <> String.Empty Then
                ' Nach Keyword suchen
                If Not (item.Vorname.ToLower.Contains(mSuchwort.ToLower) Or _
                  item.Name.ToLower.Contains(mSuchwort.ToLower)) Then
                    Return False
                End If
            End If

            If mFilterTypen Then
                ' Nur bestimmten Typ erlauben
                If mErlaubterTyp <> item.Typ Then
                    Return False
                End If
            End If

            ' Geburtstagsgrenze
            If item.Geburtsdatum < mNurJuengerAls Then
                Return False
            End If

            ' und so weiter ...

            Return True
        Else
            Return False
        End If
    End Function
End Class
