﻿Imports System.ComponentModel



Public Enum KontaktEigenschaft
    Name
    Vorname
    Typ
    Geburtsdatum
End Enum



Public Class KontaktSortierer
    Implements IComparer

    Private mSortiertNach As KontaktEigenschaft = KontaktEigenschaft.Name
    Private mSortierRichtung As ListSortDirection = ListSortDirection.Ascending

    Public Property SortiertNach() As KontaktEigenschaft
        Get
            Return mSortiertNach
        End Get
        Set(ByVal value As KontaktEigenschaft)
            mSortiertNach = value
        End Set
    End Property
    Public Property SortierRichtung() As ListSortDirection
        Get
            Return mSortierRichtung
        End Get
        Set(ByVal value As ListSortDirection)
            mSortierRichtung = value
        End Set
    End Property

    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
      Implements System.Collections.IComparer.Compare

        Dim itemX As Kontakt = TryCast(x, Kontakt)
        Dim itemY As Kontakt = TryCast(y, Kontakt)
        If itemX IsNot Nothing AndAlso itemY IsNot Nothing Then
            Dim sortMultiplier As Integer = 0
            If mSortierRichtung = ListSortDirection.Ascending Then : sortMultiplier = 1
            Else : sortMultiplier = -1
            End If
            Select Case mSortiertNach
                Case KontaktEigenschaft.Name
                    Return String.Compare(itemX.Name, itemY.Name) * sortMultiplier
                Case KontaktEigenschaft.Vorname
                    Return String.Compare(itemX.Vorname, itemY.Vorname) * sortMultiplier
                Case KontaktEigenschaft.Typ
                    If CInt(itemX.Typ) > CInt(itemY.Typ) Then
                        Return 1 * sortMultiplier
                    ElseIf CInt(itemX.Typ) < CInt(itemY.Typ) Then
                        Return -1 * sortMultiplier
                    Else
                        Return 0
                    End If
                Case KontaktEigenschaft.Geburtsdatum
                    Return Date.Compare(itemX.Geburtsdatum, itemY.Geburtsdatum) * sortMultiplier
            End Select
        End If
        Return -1
    End Function

End Class
